diff -bruN freeswan-1.9.orig/pluto/demux.c freeswan-1.9/pluto/demux.c
--- freeswan-1.9.orig/pluto/demux.c	Wed Jan 24 18:09:33 2001
+++ freeswan-1.9/pluto/demux.c	Tue Jun 12 10:58:26 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: demux.c,v 1.95 2001/01/24 23:09:33 dhr Exp $
+ * RCSID $Id: demux.c,v 1.104 2001/05/28 19:18:18 dhr Exp $
  */
 
 /* Ordering Constraints on Payloads
@@ -139,6 +139,10 @@
 #include "whack.h"	/* requires connections.h */
 #include "server.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#endif
+
 /* This file does basic header checking and demux of
  * incoming packets.
  */
@@ -153,12 +157,12 @@
  */
 
 struct state_microcode {
-    int state;
+    enum state_kind state;
     lset_t flags;
     lset_t req_payloads;	/* required payloads (allows just one) */
     lset_t opt_payloads;	/* optional payloads (any mumber) */
     u_int8_t first_out_payload;	/* if not ISAKMP_NEXT_NONE, payload to start with */
-    u_int8_t timeout_event;
+    enum event_type timeout_event;
     state_transition_fn *processor;
 };
 
@@ -190,13 +194,14 @@
 
 /* state_microcode_table is a table of all state_microcode tuples.
  * It must be in order of state (the first element).
- * After initialization, state_microcode_index[s] points to the
+ * After initialization, ike_microcode_index[s] points to the
  * first entry in state_microcode_table for state s.
  * Remember that each state name in Main or Quick Mode describes
  * what has happened in the past, not what this message is.
  */
 
-static const struct state_microcode *state_microcode_index[STATE_ROOF];
+static const struct state_microcode
+    *ike_microcode_index[STATE_IKE_ROOF - STATE_IKE_FLOOR];
 
 static const struct state_microcode state_microcode_table[] = {
 #define PT(n) ISAKMP_NEXT_##n
@@ -241,11 +246,19 @@
 
     { STATE_MAIN_R1, SMF_PKE_AUTH
     , P(KE) | P(ID) | P(NONCE), P(VID) | P(HASH), PT(KE)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inI2_outR2_pk },
+#endif
 
     { STATE_MAIN_R1, SMF_RPKE_AUTH
     , P(NONCE) | P(KE) | P(ID), P(VID) | P(HASH) | P(CERT), PT(NONCE)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inI2_outR2_rpk },
+#endif
 
     /* for states from here on, output message must be encrypted */
 
@@ -263,11 +276,20 @@
 
     { STATE_MAIN_I2, SMF_PKE_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
     , P(KE) | P(ID) | P(NONCE), P(VID), PT(HASH)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inR2_outI3_pk /* ??? not yet implemented */ },
+#endif
 
-    { STATE_MAIN_I2, SMF_ALL_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
-    ,  P(NONCE) | P(KE) | P(ID), P(VID), PT(HASH)
+    { STATE_MAIN_I2, SMF_RPKE_AUTH | SMF_INITIATOR | SMF_OUTPUT_ENCRYPTED
+/*   ,  P(NONCE) | P(KE) | P(ID), P(VID), PT(HASH) */
+    ,  P(NONCE) | P(KE) | P(ID), P(VID) | P(CERT), PT(HASH)
+#ifndef OPENSSL
     , EVENT_RETRANSMIT, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_RETRANSMIT, main_inR2_outI3_rpk /* ??? not yet implemented */ },
+#endif
 
     /* for states from here on, input message must be encrypted */
 
@@ -282,11 +304,19 @@
 
     { STATE_MAIN_R2, SMF_DS_AUTH | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(ID) | P(SIG), P(VID) | P(CERT), PT(ID)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, main_inI3_outR3 },
+#else
+    , EVENT_SA_REPLACE, main_inI3_outR3_whichds},
+#endif
 
     { STATE_MAIN_R2, SMF_PKE_AUTH | SMF_RPKE_AUTH | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(HASH), P(VID), PT(HASH)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_SA_REPLACE, main_inI3_outR3_pk},
+#endif
 
     /* STATE_MAIN_I3: R3 --> done
      * SMF_PSK_AUTH: HDR*, IDr1, HASH_R --> done
@@ -300,11 +330,20 @@
 
     { STATE_MAIN_I3, SMF_DS_AUTH | SMF_INITIATOR | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(ID) | P(SIG), P(VID) | P(CERT), PT(NONE)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, main_inR3 },
+#else
+    , EVENT_SA_REPLACE, main_inR3_whichds },
+#endif
 
     { STATE_MAIN_I3, SMF_PKE_AUTH | SMF_RPKE_AUTH | SMF_INITIATOR | SMF_FIRST_ENCRYPTED_INPUT | SMF_ENCRYPTED
     , P(HASH), P(VID), PT(NONE)
+#ifndef OPENSSL
     , EVENT_SA_REPLACE, unexpected /* ??? not yet implemented */ },
+#else
+    , EVENT_SA_REPLACE, main_inR3_pk },
+#endif
+
 
     /* STATE_MAIN_R3: can only get here due to packet loss */
     { STATE_MAIN_R3, SMF_ALL_AUTH | SMF_ENCRYPTED | SMF_RETRANSMIT_ON_DUPLICATE, LEMPTY, LEMPTY
@@ -378,8 +417,8 @@
 void
 init_demux(void)
 {
-    /* fill state_microcode_index:
-     * make state_microcode_index[s] point to first entry in
+    /* fill ike_microcode_index:
+     * make ike_microcode_index[s] point to first entry in
      * state_microcode_table for state s (backward scan makes this easier).
      * Check that table is in order -- catch coding errors.
      * For what it's worth, this routine is idempotent.
@@ -388,8 +427,8 @@
 
     for (t = &state_microcode_table[elemsof(state_microcode_table) - 1];;)
     {
-	passert(0 < t->state && t->state < STATE_ROOF);
-	state_microcode_index[t->state] = t;
+        passert(STATE_IKE_FLOOR <= t->state && t->state < STATE_IKE_ROOF);
+        ike_microcode_index[t->state - STATE_IKE_FLOOR] = t;
 	if (t == state_microcode_table)
 	    break;
 	t--;
@@ -467,7 +506,7 @@
 
     /* initialize md */
     md.iface = ifp;
-    md.from_state = 0;		/* not yet valid */
+    md.from_state = STATE_UNDEFINED;           /* not yet valid */
     md.st = NULL;
     md.note = NOTHING_WRONG;
     md.raw_packet.ptr = NULL;
@@ -499,9 +538,9 @@
 	} from;
 	int from_len = sizeof(from);
 	err_t from_ugh = NULL;
-	static const char undisclosed[] = "undisclosed source";
+        static const char undisclosed[] = "unknown source";
 
-	memset(&from.sa, 0x00, sizeof(from.sa));
+	zero(&from.sa);
 	packet_len = recvfrom(ifp->fd, bigbuffer, sizeof(bigbuffer), 0
 	    , &from.sa, &from_len);
 
@@ -564,7 +603,7 @@
 	    }
 	    else if (from_ugh != NULL)
 	    {
-		log_errno((e, "recvfrom() on %s failed in comm_handle; source sockaddr misformed: %s"
+		log_errno((e, "recvfrom() on %s failed in comm_handle (Pluto cannot decode source sockaddr in rejection: %s)"
 		    , ifp->rname, from_ugh));
 	    }
 	    else
@@ -600,7 +639,7 @@
 		struct cmsghdr *cm;
 		char fromstr[INET6_ADDRSTRLEN + sizeof(" port 65536")];
 
-		memset(&from.sa, 0x00, sizeof(from.sa));
+		zero(&from.sa);
 		from_len = sizeof(from);
 
 		emh.msg_name = &from.sa;	/* ??? filled in? */
@@ -1053,8 +1092,7 @@
      * Look up the appropriate microcode based on state and
      * possibly Oakley Auth type.
      */
-    passert(STATE_MAIN_R0 <= md.from_state && md.from_state <= STATE_INFO_PROTECTED);
-    smc = state_microcode_index[md.from_state];
+    smc = ike_microcode_index[md.from_state - STATE_IKE_FLOOR];
 
     if (md.st != NULL)
     {
@@ -1197,9 +1235,9 @@
 
     /* Digest the message.
      * Padding must be removed to make hashing work.
-     * Padding comes from encryption (so this code must be after decryption)
-     * and from the requirement that messages must be "aligned" (padded
-     * to a multiple of 4 octets).
+     * Padding comes from encryption (so this code must be after decryption).
+     * Padding rules are described before the definition of
+     * struct isakmp_hdr in packet.h.
      */
     {
 	struct payload_digest *pd = md.digest;
@@ -1241,6 +1279,9 @@
 	    {
 		lset_t s = LELEM(np);
 
+                loglog(RC_LOG_SERIOUS, "parsing: (%s)",
+                   enum_show(&payload_names, np));
+
 		if (0 == (s & (needed | smc->opt_payloads
 		| LELEM(ISAKMP_NEXT_N) | LELEM(ISAKMP_NEXT_D))))
 		{
@@ -1253,6 +1294,267 @@
 		needed &= ~s;
 	    }
 
+#ifdef OPENSSL
+            {
+              /* This code really shouldn't be here - it should be in */
+              /* the ipsec_doi code section with all the other protocol */
+              /* spec. Unfortunately, the "syntax checking" of the payload */
+              /* is done here, and the "semantic checking" of the payload */
+              /* is over in ipsec_doi. Since the fields of the ID payload */
+              /* are encrypted, and the ipsec_doi code checks those fields */
+              /* before processing the ID payload, we must ensure that the */
+              /* payload is decrypted and stored in the identification */
+              /* structure *before* the main mode routines process it. So */
+              /* the code is here. */
+ 
+              if ((IS_PHASE1(md.from_state)) && (md.st)) {
+                if ((md.st->st_oakley.auth == OAKLEY_RSA_ENC) || 
+                    (md.st->st_oakley.auth == OAKLEY_ELGAMAL_ENC)) {
+                  if ((sd == &isakmp_identification_desc) ||
+                      (sd == &isakmp_nonce_desc)) {
+                    /* We need to decrypt this packet */
+                    char cpl[65], ppl[65];
+                    u_int16_t paylen;
+                    chunk_t ch;
+ 
+                    /* see macro in defs.h */
+                    readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                    clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, 
+                      "Ciphertext payload");
+ 
+                    /* Make a copy chunk of the payload after the generic */
+                    /* header, which should be the ciphertext of */
+                    /* the ID payload */
+                    if (sd == &isakmp_identification_desc) {
+                      snprintf(cpl, sizeof(cpl)-1, "ID payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1, "ID payload (plaintext): ");
+                    } else if (sd == &isakmp_nonce_desc) {
+                      snprintf(cpl, sizeof(cpl)-1,
+                               "Nonce payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1,
+                               "Nonce payload (plaintext): ");
+                    } else {
+                      snprintf(cpl, sizeof(cpl)-1,
+                               "Unknown payload (ciphertext): ");
+                      snprintf(ppl, sizeof(ppl)-1,
+                               "Unknown payload (plaintext): ");
+                    }
+ 
+                    if (!valid_ciphertext_length(paylen - 4, md.st->st_connection)) {
+                      log("Ciphertext length not a multiple of key modulus length for %s", cpl );
+                      free_md(&md);
+                      return;
+                    }
+
+                    DBG(DBG_RAW,
+                    DBG_dump_chunk(cpl, ch);
+                    );
+
+                    if (! privkey_decrypt_chunk( &ch, md.st )) {
+                      log("Ciphertext for %s could not be decrypted.", cpl );
+                      free_md(&md);
+                      return;
+                    }
+
+                    if ((ch.len == 0) || (ch.len > paylen)) {
+                      /* Error - the decryption has failed */
+                      log("Decryption failure - malformed payload in packet");
+                      free_md(&md);
+                      return;
+                    }
+
+                    DBG(DBG_RAW,
+                    DBG_dump_chunk(ppl, ch);
+                    );
+
+/*  ** a nice data dumper **
+ * {
+ * 	int *ptr = (int *) md.message_pbs.cur;
+ * 	int length = md.message_pbs.roof -  md.message_pbs.cur;
+ * 	int i;
+ * 	DBG_log("before memcopy: ---------------------- length %d", length);
+ * 	for (i=0; i<length/4; i+=4) {
+ * 		DBG_log("%4d: %08x %08x %08x %08x ", i*4, ntohl(ptr[0]), 
+ * 			ntohl(ptr[1]), ntohl(ptr[2]), ntohl(ptr[3]));
+ * 		ptr += 4;
+ * 	}
+ * }
+ */
+
+                    /* Now restructure the message_pbs block, so that the */ 
+                    /* plaintext is now stored in the ID/nonce payload space */
+                    /* Adjust the length first */
+                    /* see macro in defs.h */
+                    writemem_u_int16_t(md.message_pbs.cur, 2, (ch.len + 4));
+
+                    /* Now copy the plaintext */
+                    memcpy(&(md.message_pbs.cur[4]), ch.ptr, ch.len);
+                    /* Clear the source plaintext */
+                    memset(ch.ptr, 0, ch.len);
+
+                    /* Shift down all subsequent payloads */
+                    memmove(&(md.message_pbs.cur[ch.len+4]),
+                            &(md.message_pbs.cur[paylen]),
+                            md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+
+                    /* Adjust the size of root downwards */
+                    md.message_pbs.roof -= paylen - ch.len - 4;
+                    freeanychunk(ch);
+
+                  }
+                } else if ((md.st->st_oakley.auth == OAKLEY_RSA_ENC_REV) ||
+			   (md.st->st_oakley.auth == OAKLEY_ELGAMAL_ENC_REV)) {
+                  if ((sd == &isakmp_identification_desc) ||
+                      (sd == &isakmp_nonce_desc) ||
+                      (sd == &isakmp_keyex_desc) ||
+                      (sd == &isakmp_ipsec_certificate_desc)) {
+                    if (sd == &isakmp_nonce_desc) {
+                      /* Nonce is public key encrypted */
+                      u_int16_t paylen;
+                      chunk_t ch;
+ 
+                      /* see macro in defs.h */
+                      readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                      clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, 
+                        "Ciphertext payload");
+
+                      if (!valid_ciphertext_length(paylen - 4, 
+                        md.st->st_connection)) {
+                        log("Ciphertext length not a multiple of key modulus length for nonce" );
+                        free_md(&md);
+                        return;
+                      }
+
+                      DBG(DBG_PARSING | DBG_CRYPT, 
+                      DBG_dump_chunk("Nonce payload (ciphertext)", ch);
+                      );
+
+                      if (! privkey_decrypt_chunk( &ch, md.st )) {
+                        log("Ciphertext for %s could not be decrypted.",
+                          "Nonce payload (ciphertext)");
+                        free_md(&md);
+                        return;
+                      }
+
+                      if ((ch.len == 0) || (ch.len > paylen)) {
+                        /* Error - the decryption has failed */
+                        log("Decryption failure - malformed payload in packet");
+                        free_md(&md);
+                        return;
+                      }
+                      DBG(DBG_PARSING | DBG_CRYPT, 
+                      DBG_dump_chunk("Nonce payload (plaintext)", ch);
+                      );
+
+		      if ((md.st->st_state == STATE_MAIN_I1) ||
+			  (md.st->st_state == STATE_MAIN_I2) ||
+			  (md.st->st_state == STATE_MAIN_I3) ||
+			  (md.st->st_state == STATE_MAIN_I4)) {
+			if (derive_symmetric_key(md.st, ch,
+						 md.st->st_rcookie,
+						 COOKIE_SIZE,
+						 &md.st->st_ks_r,
+						 &md.st->st_ne_r) < 0) {
+			  log("Unable to derive symmetric key");
+			  free(&md);
+			  return;
+			}
+			memset(&md.st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+			DBG(DBG_PARSING,
+			DBG_dump_chunk("Received Ke_r:", md.st->st_ne_r);
+			);
+		      } else {
+			if (derive_symmetric_key(md.st, ch,
+						 md.st->st_icookie,
+						 COOKIE_SIZE,
+						 &md.st->st_ks_i,
+						 &md.st->st_ne_i) < 0) {
+			  log("Unable to derive symmetric key");
+			  free(&md);
+			  return;
+			}
+			memset(&md.st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+			DBG(DBG_PARSING,
+			DBG_dump_chunk("Received Ke_i:", md.st->st_ne_i);
+			);
+		      }
+
+                      /* Now restructure the message_pbs block, so that the */
+                      /* plaintext is now stored in the payload space */
+                      /* Adjust the length first */
+                      /* see macro in defs.h */ 
+                      writemem_u_int16_t(md.message_pbs.cur, 2, (ch.len + 4));
+
+                      /* Now copy the plaintext */
+                      memcpy(&(md.message_pbs.cur[4]), ch.ptr, ch.len);
+                      /* Clear the source plaintext */
+                      memset(ch.ptr, 0, ch.len);
+                      /* Shift down all subsequent payloads */
+                      memmove(&(md.message_pbs.cur[ch.len+4]),
+                              &(md.message_pbs.cur[paylen]),
+                              md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+		      /* Adjust the size of roof downwards */
+                      md.message_pbs.roof -= paylen - ch.len - 4;
+
+		      /* Discard the plaintext chunk */
+		      memset(ch.ptr, 0, ch.len);
+		      freeanychunk(ch);
+		    } else {
+                      u_int16_t paylen;
+                      chunk_t ch, pch;
+ 
+                      /* see macro in defs.h */
+                      readmem_u_int16_t(md.message_pbs.cur, 2, paylen);
+
+                      DBG(DBG_CRYPT, 
+		      DBG_log("Encrypted payload length = %d", paylen);
+                      );
+                      clonetochunk(ch, &(md.message_pbs.cur[4]), paylen-4, "Ciphertext payload");
+		      setchunk(pch, NULL, 0);
+		      if ((md.st->st_state == STATE_MAIN_I1) ||
+			  (md.st->st_state == STATE_MAIN_I2) ||
+			  (md.st->st_state == STATE_MAIN_I3) ||
+			  (md.st->st_state == STATE_MAIN_I4)) {
+			if (! decrypt_payload(md.st, &md.st->st_ks_r,
+					      md.st->st_ne_r_iv,
+					      ch, &pch) ) {
+			  log("Unable to decrypt responder payload");
+			  free(&md);
+			  return;
+			}
+		      } else {
+			if (!decrypt_payload(md.st, &md.st->st_ks_i,
+					     md.st->st_ne_i_iv,
+					     ch, &pch) ) {
+			  log("Unable to decrypt initiator payload");
+			  free(&md);
+			  return;
+			}
+		      }
+                      /* see macro in defs.h */ 
+                      writemem_u_int16_t(md.message_pbs.cur, 2, (pch.len + 4));
+
+                      /* Now copy the plaintext */
+                      memcpy(&(md.message_pbs.cur[4]), pch.ptr, pch.len);
+                      /* Shift down all subsequent payloads */
+                      memmove(&(md.message_pbs.cur[pch.len+4]),
+                              &(md.message_pbs.cur[paylen]),
+                              md.message_pbs.roof - &(md.message_pbs.cur[paylen]));
+		      /* Adjust the size of roof downwards */
+                      md.message_pbs.roof -= paylen - pch.len - 4;
+
+		      freeanychunk(ch);
+		      memset(pch.ptr, 0, pch.len);
+		      freeanychunk(pch);
+		    }
+		  } /* Otherwise, let everything else pass */
+		} /* end if (revised PK mode ) */
+	      } /* end if Phase 1 */
+	    } /* end OPENSSL handling */
+#endif /* OPENSSL */
+                                                                             
 	    if (!in_struct(&pd->payload, sd, &md.message_pbs, &pd->pbs))
 	    {
 		loglog(RC_LOG_SERIOUS, "%smalformed payload in packet", excuse);
@@ -1456,8 +1758,9 @@
 	    case STF_IGNORE:
 		break;
 	    case STF_NO_REPLY:
-	    case STF_REPLY:
 	    case STF_UNPEND_QUICK:
+            case STF_REPLY:
+            case STF_REPLY_UNPEND_QUICK:
 		/* Delete previous retransmission event.
 		 * New event will be scheduled below.
 		 */
@@ -1484,7 +1787,7 @@
 		freeanychunk(md.st->st_tpacket);
 
 		/* if requested, send the new reply packet */
-		if (result == STF_REPLY)
+		if (result == STF_REPLY || result == STF_REPLY_UNPEND_QUICK)
 		{
 		    close_output_pbs(&md.reply);   /* good form, but actually a no-op */
 
@@ -1502,7 +1805,7 @@
 		/* Schedule for whatever timeout is specified */
 		{
 		    time_t delay;
-		    int kind = smc->timeout_event;
+		    enum event_type kind = smc->timeout_event;
 
 		    switch (kind)
 		    {
@@ -1596,15 +1899,18 @@
 			, state_story[md.st->st_state - STATE_MAIN_R0]);
 		}
 
-		if (result == STF_UNPEND_QUICK && md.st->st_pending_quick)
+		if (result == STF_UNPEND_QUICK
+                || result == STF_REPLY_UNPEND_QUICK)
 		{
-		    struct connection *c = md.st->st_connection;
-
-		    DBG(DBG_CONTROL, DBG_log("Doing Quick Mode with %s \"%s\""
-			, ip_str(&c->that.host_addr), c->name));
-		    (void) quick_outI1(dup_any(md.st->st_whack_sock)
-			, md.st, c, md.st->st_policy, 1);
-		    md.st->st_pending_quick = FALSE;
+                   /* Initiate any Quick Mode negotiations that
+                    * were waiting to piggyback on this Keying Channel.
+                    *
+                    * ??? there is a potential race condition
+                    * if we are the responder: the initial Phase 2
+                    * message might outrun the final Phase 1 message.
+                    * I think that retransmission will recover.
+                    */
+                   unpend(md.st);
 		}
 
 		if (IS_ISAKMP_SA_ESTABLISHED(md.st->st_state)
@@ -1634,14 +1940,6 @@
 		delete_state(md.st);
 		md.st = NULL;
 		break;
-
-	    case STF_DROP_DOOMED_EXCHANGE:
-		loglog(RC_LOG_SERIOUS, "dropping exchange to avoid Pluto 1.0 bug"
-		    " handling DH shared secret with leading zero byte");
-		delete_event(md.st);
-		delete_state(md.st);
-		md.st = NULL;
-		break;
 #endif
 
 	    default:	/* a shortcut to STF_FAIL, setting md.note */
@@ -1666,3 +1964,294 @@
     }
     free_md(&md);
 }
+
+#ifdef OPENSSL
+int
+derive_symmetric_key( struct state *st, const chunk_t nonce,
+		      const u_char *seedptr, const size_t seedlen,
+		      keysched *ks,
+		      chunk_t *key )
+{
+  struct hmac_ctx ctx;
+  chunk_t k, kk, kchain;
+  chunk_t ne;
+  char nestr[8];
+  int needed_len;
+
+  DBG(DBG_PARSING, 
+	  DBG_dump_chunk("Deriving symmetric key from: ", nonce);
+	  DBG_dump("Initial Cookie:", seedptr, seedlen);
+	);
+  switch(st->st_oakley.encrypt) {
+    /* We really shouldn't deal with DES, */
+    /* uncomment this if you must have it */
+  case OAKLEY_DES_CBC:
+    needed_len = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    needed_len = IDEA_CBC_KEY_LEN;
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    needed_len = BLOWFISH_CBC_KEY_LEN;
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    needed_len = RC5_CBC_KEY_LEN;
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    needed_len = DES_CBC_BLOCK_SIZE * 3;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    needed_len = CAST_CBC_KEY_LEN;
+    break;
+#endif
+  default:
+    log("Unknown block cipher ID for symmetric cipher");
+    return -1;
+  }
+
+  /* Generate initial decryption key material */
+  /* key = prf(Nonce-X, Cookie-X); X={I,R} */
+  ne.ptr = NULL;
+  hmac_init_chunk(&ctx, st->st_oakley.hasher, nonce);
+  hmac_update(&ctx, seedptr, seedlen);
+  hmac_final_chunk(ne, nestr, &ctx);
+  clonetochunk(*key, ne.ptr, ne.len, "Initial key material");
+
+  if (key->len < needed_len) {
+    freeanychunk(*key);
+    kchain.ptr = alloc_bytes(1, "initial zero octet");
+    kchain.len = 1;
+    memset(kchain.ptr, 0, kchain.len);
+    while (key->len < needed_len) {
+      kk.ptr = NULL;
+      hmac_init_chunk(&ctx, st->st_oakley.hasher, ne);
+      hmac_update_chunk(&ctx, kchain);
+      hmac_final_chunk(kk, "extra key material", &ctx);
+      clonereplacechunk(kchain, kk.ptr, kk.len, "chain key material");
+      /* Now append kk to key */
+      if (! key->ptr ) {
+	clonetochunk(*key, kk.ptr, kk.len, "initial extra key material");
+      } else {
+	k.ptr = alloc_bytes(key->len + kk.len, "appended key material");
+	k.len = key->len + kk.len;
+	memcpy(k.ptr, key->ptr, key->len);
+	memcpy(&(k.ptr[key->len]), kk.ptr, kk.len);
+	freeanychunk(*key);
+	key->len = k.len;
+	key->ptr = k.ptr;
+      }
+      freeanychunk(kk);
+    }
+    freeanychunk(kchain);
+  }
+
+  switch(st->st_oakley.encrypt) {
+    /* We really shouldn't deal with DES, */
+    /* uncomment this if you must have it */
+  case OAKLEY_DES_CBC:
+    (void)des_set_key((des_cblock *)key->ptr, ks->des_ks);
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    (void)des_set_key((des_cblock *)key->ptr + 0, ks->des3_ks.ks[0]);
+    (void)des_set_key((des_cblock *)key->ptr + 1, ks->des3_ks.ks[1]);
+    (void)des_set_key((des_cblock *)key->ptr + 2, ks->des3_ks.ks[2]);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  return 0;
+}
+
+bool
+encrypt_payload( struct state *st, keysched *ks, u_char *iv,
+		 chunk_t inp, chunk_t *out )
+{
+  chunk_t temp;
+  int blocklen;
+  u_char pv;
+
+  switch(st->st_oakley.encrypt) {
+  case OAKLEY_DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  /* Pad the input up to a block size multiple */
+  if (inp.len % blocklen == 0) { /* Add a full block for padding */
+    pv = (u_char)blocklen;
+    temp.len = inp.len + (size_t)pv;
+  } else {
+    pv = (u_char)(blocklen - 1  - ((inp.len + blocklen - 1) % blocklen));
+    temp.len = inp.len + (size_t)pv;
+  }
+
+  temp.ptr = alloc_bytes(temp.len, "padded plaintext");
+  memset(temp.ptr, 0, temp.len);
+  clonetochunk(*out, temp.ptr, temp.len, "ciphertext");
+  memcpy(temp.ptr, inp.ptr, inp.len);
+  temp.ptr[temp.len-1] = pv;
+  
+  DBG(DBG_PARSING | DBG_CRYPT,
+	  DBG_dump_chunk("Plaintext:", temp);
+	  DBG_dump("Old IV: ", iv, blocklen);
+	);
+
+  switch(st->st_oakley.encrypt) {
+  case OAKLEY_DES_CBC:
+    des_ncbc_encrypt((des_cblock *)temp.ptr, (des_cblock *)out->ptr,
+		     temp.len, ks->des_ks, (des_cblock *)iv, TRUE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    des_ede3_cbc_encrypt((des_cblock *)temp.ptr, (des_cblock *)out->ptr,
+			 temp.len,
+			 ks->des3_ks.ks[0],
+			 ks->des3_ks.ks[1],
+			 ks->des3_ks.ks[2],
+			 (des_cblock *)iv, TRUE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Ciphertext: ", *out);
+	DBG_dump("New IV: ", iv, blocklen);
+	);
+  freeanychunk(temp);
+  return TRUE;
+}
+
+bool
+decrypt_payload( struct state *st, keysched *ks, u_char *iv,
+		 chunk_t inp, chunk_t *out )
+{
+  chunk_t temp;
+  int blocklen;
+
+  switch(st->st_oakley.encrypt) {
+  case OAKLEY_DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    blocklen = DES_CBC_BLOCK_SIZE;
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  if (inp.len % blocklen != 0) {
+    log("Ciphertext is not a multiple of block length");
+    return FALSE;
+  }
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Ciphertext: ", inp);
+	DBG_dump("Old IV: ", iv, blocklen);
+	);
+
+  temp.ptr = alloc_bytes(inp.len, "temporary plaintext");
+  temp.len = inp.len;
+  memset(temp.ptr, 0, temp.len);
+
+  switch(st->st_oakley.encrypt) {
+  case OAKLEY_DES_CBC:
+    des_ncbc_encrypt((des_cblock *)inp.ptr, (des_cblock *)temp.ptr,
+		     inp.len, ks->des_ks, (des_cblock *)iv, FALSE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_IDEA_CBC:
+    break;
+  case OAKLEY_BLOWFISH_CBC:
+    break;
+  case OAKLEY_RC5_R16_B64_CBC:
+    break;
+#endif
+  case OAKLEY_3DES_CBC:
+    des_ede3_cbc_encrypt((des_cblock *)inp.ptr, (des_cblock *)temp.ptr,
+			 inp.len,
+			 ks->des3_ks.ks[0],
+			 ks->des3_ks.ks[1],
+			 ks->des3_ks.ks[2],
+			 (des_cblock *)iv, FALSE);
+    break;
+#ifdef NOTYET
+  case OAKLEY_CAST_CBC:
+    break;
+#endif
+  }
+
+  /* Strip padding from plaintext */
+  if ((temp.ptr[temp.len-1] < (u_char)1) ||
+      (temp.ptr[temp.len-1] > (u_char)blocklen) ||
+      (temp.ptr[temp.len-1] > temp.len)) {
+    /* Impossible padding value */
+    log("Impossible plaintext padding value: %d", temp.ptr[temp.len-1]);
+    memset(temp.ptr, 0, temp.len);
+    freeanychunk(temp);
+    return FALSE;
+  }
+
+  out->len = temp.len - (size_t)(temp.ptr[temp.len-1]);
+  out->ptr = alloc_bytes(inp.len, "plaintext");
+  memcpy(out->ptr, temp.ptr, out->len);
+
+  DBG(DBG_PARSING | DBG_CRYPT,
+	DBG_dump_chunk("Plaintext: ", *out);
+	DBG_dump("New IV: ", iv, blocklen);
+	);
+
+  memset(temp.ptr, 0, temp.len);
+  freeanychunk(temp);
+  return TRUE;
+}
+
+#endif
diff -bruN freeswan-1.9.orig/pluto/demux.h freeswan-1.9/pluto/demux.h
--- freeswan-1.9.orig/pluto/demux.h	Tue Sep 12 02:59:26 2000
+++ freeswan-1.9/pluto/demux.h	Tue Jun  5 14:50:00 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: demux.h,v 1.15 2000/09/12 06:59:26 dhr Exp $
+ * RCSID $Id: demux.h,v 1.18 2001/05/05 02:51:38 dhr Exp $
  */
 
 struct state;	/* forward declaration of tag */
@@ -48,7 +48,7 @@
     pb_stream message_pbs;	/* message to be processed */
     struct isakmp_hdr hdr;	/* message's header */
     bool encrypted;	/* was it encrypted? */
-    int from_state;	/* state we started in */
+    enum state_kind from_state;        /* state we started in */
     struct state *st;	/* current state object */
     pb_stream reply;	/* room for reply */
     pb_stream rbody;	/* room for reply body (after header) */
@@ -66,14 +66,26 @@
 typedef enum {
     STF_IGNORE,	/* don't respond */
     STF_NO_REPLY,	/* success, but no reply to send */
+    STF_UNPEND_QUICK,  /* phase 1 success: initiate any phase 2 */
     STF_REPLY,	/* success, so send reply */
-    STF_UNPEND_QUICK,	/* phase 1 success; initiate any phase 2 */
+    STF_REPLY_UNPEND_QUICK,	/* reply; phase 1 success: initiate any phase 2 */
     STF_INTERNAL_ERROR,	/* discard everything, we failed */
 #ifdef DODGE_DH_MISSING_ZERO_BUG
-    STF_DROP_DOOMED_EXCHANGE,	/* we're responder -- don't respond */
     STF_REPLACE_DOOMED_EXCHANGE,	/* we're initiator -- reinitiate */
 #endif
     STF_FAIL	/* discard everything, something failed.  notification_t added. */
 } stf_status;
 
 typedef stf_status state_transition_fn(struct msg_digest *md);
+
+#ifdef OPENSSL
+extern int derive_symmetric_key( struct state *st, const chunk_t nonce,
+				 const u_char *seedptr,
+				 const size_t seedlen,
+				 keysched *ks,
+				 chunk_t *key );
+extern bool encrypt_payload( struct state *st, keysched *ks, u_char *iv,
+			   chunk_t inp, chunk_t *out );
+extern bool decrypt_payload( struct state *st, keysched *ks, u_char *iv,
+			     chunk_t inp, chunk_t *out );
+#endif /* OPENSSL */
